# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section free
%define base_name jcs

Summary:        Java Caching System
Name:           jakarta-jcs
Version:        1.3.2.8
Release:        1%{?dist}
Epoch:          0
License:        Apache Software License
URL:            http://jakarta.apache.org/jcs/
Group:          Development/Libraries
Source0:        jcs-1.3.2.8-src.tar.gz
# svn export http://svn.apache.org/repos/asf/jakarta/jcs/tags/JCS_1_3_2_8/

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        jakarta-jcs-1.3.2.8-jpp-depmap.xml
Source5:        jakarta-jcs-build.xml
Patch0:         jakarta-jcs-project.patch
%if %{with_maven}
BuildRequires:  maven >= 0:1.1
BuildRequires:  maven-plugins-base
BuildRequires:  maven-plugin-changes
BuildRequires:  maven-plugin-checkstyle
BuildRequires:  maven-plugin-ear
BuildRequires:  maven-plugin-faq
BuildRequires:  maven-plugin-jcoverage
BuildRequires:  maven-plugin-jdepend
BuildRequires:  maven-plugin-jxr
BuildRequires:  maven-plugin-license
BuildRequires:  maven-plugin-pmd
BuildRequires:  maven-plugin-tasklist
BuildRequires:  maven-plugin-test
BuildRequires:  maven-plugin-war
BuildRequires:  maven-plugin-xdoc
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  sf-cobertura-maven-plugin
%endif
BuildRequires:  junit
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  ant >= 0:1.6.5

BuildRequires:  berkeleydb
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-configuration
BuildRequires:  jakarta-commons-lang
BuildRequires:  jakarta-commons-logging
BuildRequires:  concurrent
BuildRequires:  hsqldb
BuildRequires:  jgroups
BuildRequires:  jisp2
BuildRequires:  log4j
BuildRequires:  mysql-connector-java
BuildRequires:  servlet_2_3_api
BuildRequires:  struts
BuildRequires:  tomcat5-server-lib
BuildRequires:  velocity
BuildRequires:  xmlrpc2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis

Requires:  /usr/sbin/update-alternatives
Requires:  berkeleydb
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-configuration
Requires:  jakarta-commons-lang
Requires:  jakarta-commons-logging
Requires:  concurrent
Requires:  hsqldb
Requires:  jgroups
Requires:  jisp2
Requires:  log4j
Requires:  servlet_2_3_api
Requires:  struts
Requires:  tomcat5-server-lib
Requires:  velocity
Requires:  xmlrpc2
Requires:  xerces-j2
Requires:  xml-commons-jaxp-1.3-apis
Provides:  hibernate_in_process_cache
Provides:  jakarta-turbine-jcs
Obsoletes:  jakarta-turbine-jcs
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
JCS is a distributed caching system written in java 
for server-side java applications. It is intended to 
speed up dynamic web applications by providing a means 
to manage cached data of various dynamic natures. 
Like any caching system, the JCS is most useful for 
high read, low put applications. Dynamic content and 
reporting systems can benefit most. 
However, any site that repeatedly constructs pages, 
dropdowns, or common search results form a database 
that is updated at intervals (rather than across 
categories continuously) can improve performance and 
scalability by implementing caching. Latency times drop 
sharply and bottlenecks move away from the database in 
an effectively cached system. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:  jakarta-turbine-jcs-javadoc
Obsoletes:  jakarta-turbine-jcs-javadoc

%description javadoc
Javadoc for %{name}.

%if %{with_maven}
%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation
Provides:  jakarta-turbine-jcs-manual
Obsoletes:  jakarta-turbine-jcs-manual

%description manual
Docs for %{name}.
%endif

%prep
%setup -q -n jcs-%{version}-src
# remove all binary libs
## find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
cp %{SOURCE5} build.xml
%patch0 -b .sav0

# NOTE:
# org.apache.jcs.auxiliary.lateral.socket.tcp.discovery.UDPDiscoveryUnitTest
# must enable UDP port 6789 in firewall for this test to succeed

%build
%if %{with_maven}
export DEPCAT=$(pwd)/%{name}-%{version}-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > %{name}-%{version}-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven

maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        -Dmaven.test.skip=true \
        jar javadoc xdoc:transform ear war
%else
export CLASSPATH=$(build-classpath concurrent servletapi4 velocity xmlrpc2 hsqldb):target/classes:target/test-classes:src/test-conf
ant -Dbuild.sysclasspath=only jar javadoc
%endif

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 0644 target/%{base_name}-%{version}-RC.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/ && ln -s %{name}-%{version}.jar %{base_name}-%{version}.jar)
(cd $RPM_BUILD_ROOT%{_javadir}/ && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
# ear, war
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%if %{with_maven}
install -m 0644 target/%{base_name}-%{version}-RC.ear \
                $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 0644 target/%{base_name}.war \
                $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%endif

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/docs/apidocs

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

# hibernate_in_process_cache ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/hibernate_in_process_cache.jar

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm \
%if %{with_maven}
--exclude /usr/share/%{name}-%{version}/jcs.war
%endif

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_javadir}/hibernate_in_process_cache.jar \
  hibernate_in_process_cache %{_javadir}/%{name}.jar 10
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
{
  [ $1 -eq 0 ] || exit 0
  update-alternatives --remove hibernate_in_process_cache %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*jcs*.jar
%ghost %{_javadir}/hibernate_in_process_cache.jar
%{_datadir}/%{name}-%{version}
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %{with_maven}
%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}
%endif

%changelog
* Fri Apr 24 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.3.2.8-1.jpp5
- 1.3.2.8

* Mon Aug 06 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-7jpp
- Change dependency from xmlrpc to xmlrpc2

* Fri May 04 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-6jpp
- Fix depmap for tomcat5/tomcat-util.jar
- Add more maven-plugin-* BRs

* Wed Mar 07 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-5jpp
- Add gcj_support option
- Optionally build without maven

* Wed May 10 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-4jpp
- Drop struts11, servletapi3 dependencies and use struts,servletapi4 

* Mon Mar 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7.0-3jpp
- Use tomcat-util.jar from Tomcat 5

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7.0-2jpp
- Add missing dependencies on maven-plugins

* Mon Feb 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2.7.0-1jpp
- Update to 1.2.7.0
- First JPP-1.7 release
- enabling UDP port 6789 in firewall rules is required for successful
  org.apache.jcs.auxiliary.lateral.socket.tcp.discovery.UDPDiscoveryUnitTest
- maven-simian-report has been pacthed out

* Mon Oct 31 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.6.5-0.20050611dev.3jpp
- Add Provides: jakarta-turbine-jcs-javadoc
- Add Provides: jakarta-turbine-jcs-manual

* Mon Oct 31 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.6.5-0.20050611dev.2jpp
- Change name to jakarta-jcs and provide compatibility symlinks
- Fix Url
- Obsolete jakarta-turbine-jcs

* Fri Oct 28 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.6.5-0.20050611dev.1jpp
- Upgrade to 1.2.6.5
- One test in TestUDPDiscovery failing

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-0.20031216dev.4jpp
- Rebuild with ant-1.6.2
* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.3jpp
- Relax some versioned dependencies
- provide hibernate_in_process_cache and update-alternatives, prio 10

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.2jpp
- set dependency to jisp2, instead of jisp

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.1jpp
- First JPackage release

